【转】构造函数没有正常结束时不会调用相关联的析构函数

构造函数没有正常结束时不会调用相关联的析构函数

#include <iostream>
using namespace std;


class TraceTool {
	static int _counter;
	int _objId;
public:
	TraceTool() {
		_objId = _counter++;
		cout << "constructing TraceTool #" << _objId << endl;
		if (3 == _objId) throw 3;
	}
	~TraceTool() {
		cout << "destructing TraceTool #" << _objId << endl;
	}
};

int TraceTool::_counter = 0;

int main()
{
	try {
		TraceTool n1;
		// Throws exception
		TraceTool myarray[5];
		TraceTool n2; // Won't get here
	}
	catch (int i) {
		cout << "caught " << i << endl;
	}
	getchar();
    std::cout << "Hello World!\n";
}

运行结果如下:
在这里插入图片描述
对象数组的三个元素成功创建了,但是在创建第四个数组元素的过程中构造函数抛出了一个异常。在main函数中,由于第四个构造函数(用于创建myarray[2]对象)没有完成,所以只有myarray[1]和myarray[0]对象的析构函数被调用。最后对象n1销毁。因为对象n2根本就没有创建,所以也没有销毁。

  • 0
    点赞
  • 0
    评论
  • 0
    收藏
  • 一键三连
    一键三连
  • 扫一扫,分享海报

相关推荐
©️2020 CSDN 皮肤主题: 大白 设计师:CSDN官方博客 返回首页